# -*- coding: utf-8 -*-
"""
Created on Mon Jul 28 11:54:46 2014
knn
@author: dani
"""

import numpy
import os


def knn_class_run(datum,K):
	path = os.path.dirname(__file__)
	class_data = open(path+"/knn_class_data.txt")
	DataArray=[]
	for line in class_data:
		numero=numpy.fromstring(line,dtype=float, sep=' ').tolist()
		DataArray.append(numero)
	class_data.close()
	knn_data = []
	datum = numpy.dot(datum,numpy.array(DataArray[3],dtype=float).reshape((2,2)))
	#draw
	c1_0 = []
	c2_0 = []
	c1_1 = []
	c2_1 = []
	#end draw
	for x,y,z in zip(DataArray[0],DataArray[1],DataArray[2]):
		distance = numpy.sqrt((x-datum[0])**2+(y-datum[1])**2)
		knn_data.append((z,distance,x,y))
		#draw
		if z==0:
			c1_0.append(x)
			c2_0.append(y)
		else:
			c1_1.append(x)
			c2_1.append(y)
		#end draw
	knn_data_sort = sorted(knn_data, key=lambda x: x[1])
	neighbours = knn_data_sort[0:K]
	#for x in neighbours:
	#	print x
	t1=[x[0] for x in neighbours].count(1.0)
	if t1 > float(K)/2.0:
		Result = 1
	elif t1 < float(K)/2.0:
		Result = 0
	else:
		d1 = sum([x[0]*x[1] for x in neighbours])/t1
		d0 = sum([(x[0]==0)*x[1] for x in neighbours])/t1
		if d1>d0:
			Result = 0
		elif d1<d0:
			Result = 1
		else:
			Result = neighbours[0][0]
	min_x = numpy.minimum(numpy.minimum(numpy.min(c1_0),numpy.min(c1_1)),datum[0])
	max_x = numpy.maximum(numpy.maximum(numpy.max(c1_0),numpy.max(c1_1)),datum[0])
	min_y = numpy.minimum(numpy.minimum(numpy.min(c2_0),numpy.min(c2_1)),datum[1])
	max_y = numpy.maximum(numpy.maximum(numpy.max(c2_0),numpy.max(c2_1)),datum[1])
	if Result == 0:
		r = 'Positive'
	else:
		r = 'Negative'
	aux_round = 4
	out = {'result':r,
		   'datum_x':numpy.round(datum[0],aux_round),
		   'datum_y':numpy.round(datum[1],aux_round),
		   'c1_0':numpy.round(c1_0,aux_round).tolist(),
		   'c1_1':numpy.round(c1_1,aux_round).tolist(),
		   'c2_0':numpy.round(c2_0,aux_round).tolist(),
		   'c2_1':numpy.round(c2_1,aux_round).tolist(),
		   'min_x': min_x,
		   'max_x': max_x,
		   'min_y': min_y,
		   'max_y': max_y}
	return out
	
#datum = [0.2,0.68]
#K=10
#print knn_class_run(datum,K)['Result']

