# -*- coding: utf-8 -*-
"""
Created on Mon Jul 28 11:54:46 2014
knn
@author: dani
"""

import numpy
import os


def knn_class_run(datum,K):
	path = os.path.dirname(__file__)
	class_data = open(path+"/knn_class_data.txt")
	DataArray=[]
	for line in class_data:
		numero=numpy.fromstring(line,dtype=float, sep=' ').tolist()
		DataArray.append(numero)
	class_data.close()
	knn_data = []
	datum = numpy.dot(datum,numpy.array(DataArray[3],dtype=float).reshape((2,2)))
	for x,y,z in zip(DataArray[0],DataArray[1],DataArray[2]):
		distance = numpy.sqrt((x-datum[0])**2+(y-datum[1])**2)
		knn_data.append((z,distance,x,y))
	knn_data_sort = sorted(knn_data, key=lambda x: x[1])
	neighbours = knn_data_sort[0:K]
	#for x in neighbours:
	#	print x
	t1=[x[0] for x in neighbours].count(1.0)
	if t1 > float(K)/2.0:
		Result = 1
	elif t1 < float(K)/2.0:
		Result = 0
	else:
		d1 = sum([x[0]*x[1] for x in neighbours])/t1
		d0 = sum([(x[0]==0)*x[1] for x in neighbours])/t1
		if d1>d0:
			Result = 0
		elif d1<d0:
			Result = 1
		else:
			Result = neighbours[0][0]
	if Result == 0:
		r = 'Positive'
	else:
		r = 'Negative'
	aux_round = 9
	out = {'result':r,
		   'datum_x':numpy.round(datum[0],aux_round),
		   'datum_y':numpy.round(datum[1],aux_round)}
	return out
	
#datum = [0.2,0.68]
#K=10
#print knn_class_run(datum,K)['Result']

