#encoding:utf-8

#import models
from app.models import session_data, session_channel_mask
from log_in_out.models import access_list

#import sessions
from django.contrib.sessions.models import Session

# Used to log in and to log out
from django.contrib.auth.forms import AuthenticationForm
from django.contrib.auth import login, authenticate, logout
from django.contrib.auth.decorators import login_required

#django render web
from django.shortcuts import render_to_response
from django.template import RequestContext

#django redirect
from django.http import HttpResponseRedirect

# LOG IN
def to_log_in(request):
	AppForm = AuthenticationForm()
	var=0;
	if request.method == "POST":
		AppForm = AuthenticationForm(request.POST)
		if AppForm.is_valid:
			username = request.POST['username']
			password = request.POST['password']
			user = authenticate(username=username, password=password)
			if user is not None:
				if user.is_active:
					login(request,user)
					a = access_list.objects.create(
						user_name = request.user,
						user_ip = request.META['REMOTE_ADDR'] )
					current_session_key = request.session.session_key
					#request.session["user_name"] = request.user
					url = request.GET.get('next', '/app') #'next' is the parameter you want, And '/load_file' is the default value if q isn't found.
					if session_data.objects.filter(user_name=request.user):
						b = session_data.objects.get(user_name=request.user)
						old = b.session_key
						b.session_key = current_session_key
						b.save()
						try:
							#Session.objects.filter(user_name=request.user).delete()
							Session.objects.get(pk=old).delete()
						except:
							pass
					else:
						b = session_data.objects.create(
							user_name = request.user,
							session_key = current_session_key)
						c = session_channel_mask.objects.create(
							regarding  = b,
							channel    = "",
							mask       = "")
					return HttpResponseRedirect(url)
				else:
					#El usuario no está activo, si tiene alguna duda o petición pongase en contacto con nosotros
					AppForm = ""
					var = 2
			else:
				#No constas como usuario registrado, póngase en contacto con nosotros para bla bla bla
				AppForm = ""
				var=1;
				var_web={'var':var}
		else:
			#Debe decir que el formulario no es válido 
			AppForm = AuthenticationForm()
			var=0;
			var_web={'var':var}
			return render_to_response('log_in_out/log_in.html',{'AppForm':AppForm,'var_web':var_web}, context_instance=RequestContext(request))
	elif request.user.is_anonymous():
		#si viene aquí y no está registrado se le pide el registro
		AppForm = AuthenticationForm()
		var=0;
		var_web={'var':var}
		return render_to_response('log_in_out/log_in.html',{'AppForm':AppForm,'var_web':var_web}, context_instance=RequestContext(request))
	else:
		#Si ya está registrado qué hacer
		var=3 #muestra algo como "Hola user_name"
	var_web={'var':var}
	return render_to_response('log_in_out/log_in.html',{'AppForm':AppForm,'var_web':var_web}, context_instance=RequestContext(request))

# LOG OUT
@login_required(login_url='/log_in')
def to_log_out(request):
	logout(request)
	return HttpResponseRedirect('/log_in')