from app.models import file_data, file_header, file_channel, file_mask, session_data, session_channel_mask
from django.contrib import admin


#######################
#      FILE DATA      #
#######################
class file_data_admin (admin.ModelAdmin):
	list_display = ('descriptive_name','user_name','upload_date')
	list_filter = ['user_name']

class file_channel_admin (admin.ModelAdmin):
	list_display = ('regarding', 'number')
	list_filter = ['regarding']

admin.site.register(file_data, file_data_admin)
admin.site.register(file_header)
admin.site.register(file_channel, file_channel_admin)
admin.site.register(file_mask)

##########################
#      SESSION DATA      #
##########################
class session_data_admin(admin.ModelAdmin):
	list_display = ('user_name','file_dat')
	list_filter = ['user_name']

admin.site.register(session_data, session_data_admin)
admin.site.register(session_channel_mask)