#encoding:utf-8

#import forms
from contact.forms import contact_form

#import sessions
from django.contrib.sessions.models import Session

#Email
from django.core.mail import EmailMessage

#django render web
from django.shortcuts import render_to_response
from django.template import RequestContext

#contact
def contact(request):
	if request.user.is_anonymous():
		log=0;
		name_user="anonymous"
		var_web={'user':name_user, 'log':log}
	else:
		log=1;
		var_web={'user':request.user, 'log':log}
	if request.method=='POST':
		var_web['view']=0
		form = contact_form(request.POST)
		if form.is_valid():
			name = form.cleaned_data['name']
			email = form.cleaned_data['email']
			subject = form.cleaned_data['subject']
			message = form.cleaned_data['message'] + "\n\n\nConctactar con: " + email + "\nSu nombre es: " + name + "\nEl usuario: " + str(request.user)
			tosend = EmailMessage(subject, message, to = ['actigrafia@gmail.com'])
			tosend.send()
			var_web['view']=1
			form = ""
	else:
		var_web['view']=0
		form = contact_form()
	return render_to_response('contact/contact.html',{'var_web':var_web,'form':form},context_instance=RequestContext(request))
